#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
###
# Application: wah!cade
# File:        win_message.py
# Description: message window
# Copyright (c) 2008   Andy Balcombe <http://www.anti-particle.com>
###
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
import os
import sys
import string

#gtk
import pygtk
if sys.platform != 'win32':
    pygtk.require('2.0')
import gtk
import gtk.glade
import gobject
import pango

#project modules
from constants import *
from wc_common import WahCade

class WinMessage(WahCade):
    """Wah!Cade Message Window"""
    def __init__(self, WinMain):
        #set main window
        self.WinMain = WinMain
        #build the window
        self.winMessage = gtk.Window()
        self.fixd = gtk.Fixed()
        self.imgBackground = gtk.Image()
        self.lblHeading = gtk.Label()
        self.lblMessage = gtk.Label()
        self.lblPrompt = gtk.Label()
        self.fixd.add(self.imgBackground)
        self.fixd.add(self.lblHeading)
        self.fixd.add(self.lblMessage)
        self.fixd.add(self.lblPrompt)
        self.winMessage.add(self.fixd)
        self.imgBackground.show()
        self.lblHeading.show()
        self.lblMessage.show()
        self.lblPrompt.show()
        self.fixd.show()
        self.lblMessage.set_line_wrap(True)
        self.lblPrompt.set_line_wrap(True)
        self.lblMessage.set_justify(gtk.JUSTIFY_CENTER)
        self.lblPrompt.set_justify(gtk.JUSTIFY_CENTER)
        #window options
        self.winMessage.set_decorated(False)
        self.winMessage.set_transient_for(self.WinMain.winMain)
        self.winMessage.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        self.winMessage.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_DIALOG)
        #hide mouse
        self.winMessage.show()
        if not self.WinMain.wahcade_ini.getint('show_cursor'):
            self.hide_mouse_cursor(self.winMessage)

    def display_message(self, heading='', message='', prompt=''):
        """show the required message"""
        self.winMessage.show()
        self.lblHeading.set_text(heading)
        self.lblMessage.set_text(message)
        self.lblPrompt.set_text(prompt)
        self.do_events()

    def hide(self):
        """hide message window"""
        self.winMessage.hide()
        self.do_events()
